#include <vga.h>

void bpp8_scroll_1024_up(int x,int y,int w,int h,int line)
{
  char * bmp;
  int H;
  int upline   = y * 1024 + x;
  int downline = (y+line) * 1024 + x;
  int page = 0;
  
  bmp = (char*)malloc(w*sizeof(char));
  H = h - line;
  vga_setpage(downline>>16);
  while (H>0) {
    if (page) vga_setpage(downline>>16);
    memcpy(bmp,(graph_mem+(downline&0xffff)),w);
    if (page) vga_setpage(upline>>16);
    memcpy((graph_mem+(upline&0xffff)),bmp,w);
    upline += 1024; downline += 1024; H--;
    page = ((upline&0xff0000)!=(downline&0xff0000));
    if (!page) { if ((upline&0xffff)<1024) page++;  }
  }
  free(bmp);

}

void bpp8_scroll_1024_down(int x,int y,int w,int h,int line)
{
  char * bmp;
  int H;
  int downline = (y+h-1)*1024 + x;
  int upline = downline - line * 1024;
  int page = 0;
  
  bmp = (char*)malloc(w*sizeof(char));
  H = h - line;

  vga_setpage(upline>>16);
  while (H>0) {
    if (page) vga_setpage(upline>>16);
    memcpy(bmp,(graph_mem+(upline&0xffff)),w);
    if (page) vga_setpage(downline>>16);
    memcpy((graph_mem+(downline&0xffff)),bmp,w);
    upline -= 1024; downline -= 1024; H--;
    page = ((upline&0xff0000)!=(downline&0xff0000));
    if (!page) { if ((0x10000-(downline&0xffff))<1024) page=1;  }
  }
  
  free(bmp);
}

int bpp8_scroll_1024(int x,int y,int w,int h,int line)
{
  if (line>0) bpp8_scroll_1024_up(x,y,w,h,line); else
  if (line<0) bpp8_scroll_1024_down(x,y,w,h,-line);
  return line;
}
